# Curio1: browse a tiny state space of 8 programs involving fractals

[![0 dependencies!](https://0dependencies.dev/0dependencies.svg)](https://0dependencies.dev)

Press 'x' to toggle between two fractals, the Hilbert Curve and Fibonacci
Curve.

Press 'y' to toggle smart positioning on or off.

Press 'z' to toggle a couple of interactive sliders.

Press 'd' to toggle between showing+running one program and comparing two programs.
For example:
- 'dx' will compare the current program with the corresponding program using the other fractal.
- 'dy' will compare the current program with smart positioning toggled.
- 'dz' will compare the current program with interactive sliders toggled.

When comparing two programs, pressing 'd' will go back to showing+running one
program.

## Getting started

Install [LÖVE](https://love2d.org). It's just a 5MB download, open-source and
extremely well-behaved.

To run from the terminal, [pass this directory to LÖVE](https://love2d.org/wiki/Getting_Started#Running_Games),
optionally with a file path to edit.

Alternatively, turn it into a .love file you can double-click on:
```
$ zip -r /tmp/curio1.love *.lua
```

By default, curio1.love reads/writes the file `lines.txt` in
[a directory relative to this app](https://love2d.org/wiki/love.filesystem.getSourceBaseDirectory).

To open a different file, drop it on the curio1.love window.

## Keyboard shortcuts

While editing text:
* `ctrl+c` to copy
* `ctrl+=` to zoom in, `ctrl+-` to zoom out, `ctrl+0` to reset zoom
* mouse drag to select text, `ctrl+a` to select all

Exclusively tested so far with a US keyboard layout. If
you use a different layout, please let me know if things worked, or if you
found anything amiss: http://akkartik.name/contact

## Known issues

* No support yet for Unicode graphemes spanning multiple codepoints.

* No support yet for right-to-left languages.

* If you ever see a crash when clicking on the mouse, it might be because a
  mouse press and release need to happen in separate frames. Try pressing and
  releasing more slowly and let me know if that helps or not. This is klunky,
  sorry.

* Can't scroll while selecting text with mouse.

* No scrollbars yet. That stuff is hard.

## Mirrors and Forks

This repo is a fork of [lines.love](http://akkartik.name/lines.html).
Its immediate upstream is [highlight.love](https://git.sr.ht/~akkartik/highlight.love),
a viewer for plain text with color markup.
Updates to it can be downloaded from:

* https://akkartik.name/curio1.love

Further forks are encouraged. If you show me your fork, I'll link to it here.

## Feedback

[Most appreciated.](http://akkartik.name/contact) Messages, PRs, patches,
forks, it's all good.
