local my_string = {}

function my_string.split(str, delim)
  if delim == nil then
    delim = '%s'
  end
  local result = {}
  for s in string.gmatch(str, '[^'..delim..']+') do
    table.insert(result, s)
  end
  return result
end

function my_string.trim(s)
  return s:gsub('^%s+', ''):gsub('%s+$', '')
end

function my_string.ltrim(s)
  return s:gsub('^%s+', '')
end

function my_string.rtrim(s)
  return s:gsub('%s+$', '')
end

return my_string
