require('widgets')

function slider(var, x0, x1, y, lo, hi)
  local x = x0 + ((_G[var] - lo)/(hi - lo) * (x1-x0))
  assert(x >= x0 and x <= x1)
  local w,h = 20,20
  local selected = false
  local draw = function()
    love.graphics.setColor(0,0,1, 0.6)
    love.graphics.line(x0,y, x1,y)
    love.graphics.print(('%0.3f'):format(lo), x0-2, y+h/2+2)
    love.graphics.print(('%0.3f'):format(hi), x1+2, y+h/2+2)
    love.graphics.rectangle('fill', x-w/2, y-h/2, w,h)
  end
  local ispress = function(x2,y2)
    return x2 >= x-w/2 and x2 <= x+w/2 and y2 >= y-h/2 and y2 <= y+h/2
  end
  local press = function() selected = true end
  local update = function(dt, x2,y2)
    if selected then
      x = math.min(math.max(x2, x0), x1)
      _G[var] = lo + (x-x0)/(x1-x0)*(hi-lo)
    end
  end
  local release = function() selected = false end
  return {draw=draw, ispress=ispress, press=press, update=update, release=release}
end
