local utils = {}

-- https://stackoverflow.com/questions/640642/how-do-you-copy-a-lua-table-by-value/26367080#26367080
function utils.deepcopy(obj, seen)
  if type(obj) ~= 'table' then return obj end
  if seen and seen[obj] then return seen[obj] end
  local s = seen or {}
  local result = setmetatable({}, getmetatable(obj))
  s[obj] = result
  for k,v in pairs(obj) do
    result[utils.deepcopy(k, s)] = utils.deepcopy(v, s)
  end
  return result
end

function utils.minmax(a, b)
  return math.min(a,b), math.max(a,b)
end

function utils.set_color_from_table(color)
  love.graphics.setColor(color.r, color.g, color.b, color.a)
end

function utils.width(s)
  return love.graphics.getFont():getWidth(s)
end

function utils.is_int(n)
  return math.floor(n) == n
end

return utils
