-- helper screen for creating UI widgets on screen
widgets = {}
long_press_duration = 1

function widgets.__draw()
  for name,w in pairs(widgets) do
    if name:find('__') == nil and w.draw then
      w.draw()
    end end end

function widgets.__mousepressed(x,y, b)
  for name,w in pairs(widgets) do
    if name:find('__') == nil then
      if w.ispress(x,y) then
        return w.press()
      end end end end

function widgets.__update(dt)
  local x, y = love.mouse.getPosition()
  local mouse_down = love.mouse.isDown(1)
  for name,w in pairs(widgets) do
    if name:find('__') == nil then
      if w.update then w.update(dt, x,y) end
      if w.long_press then
        if mouse_down and w.ispress(x,y) then
          if w.press_time == nil then
            w.press_time = 0
          else
            w.press_time = w.press_time+dt
            if w.press_time > long_press_duration then
              w.long_press()
              w.press_time = nil
            end
          end
        else
          w.press_time = nil
        end
      end end end end

function widgets.__mousereleased(x,y, b)
  for name,w in pairs(widgets) do
    if name:find('__') == nil and w.release then
      w.release()
    end end end
